% This is a demo for the Reduced Analytic Dependency Modeling (RADM) algorithm. 

% Please cite our paper, if you use this code for your project. Thanks.
% Andy J Ma and Pong C Yuen, "Reduced Analytic Dependency Modeling: Robust Fusion for Visual Recognition," 
% International Journal of Computer Vision, 2014.

clc
clear

load scores_kth

% convet tag to matrix format in case of multiple label
tag_train_mat = zeros(num_actions, length(tag_train));
for i = 1:num_actions
    tag_train_mat(i,:) = tag_train==i;
end

% 
cond_DM = radmlsmcrank(prob_training, tag_train_mat, 4, 3, 1e2, 1e-2, prob_testing);
[~, labs_DM_test] = max(cond_DM,[],2);
rate_correct_DM = sum(labs_DM_test == tag_test')  / length(tag_test);
display(['correct rate: ' num2str(max(rate_correct_DM))])

