function [cond_DM, cond_DM_train] = radmlsmcrank(prob_training, tag_train_mat, order_r, order_k, lamda, miu, prob_testing)

num_actions = size(prob_training, 3);
num_feas = size(prob_training, 2);
num_train_veds = size(prob_training, 1);
num_test_veds = size(prob_testing, 1);

ind_mat = 0:order_k;
scores_train = ones(num_train_veds, 1, num_actions);
scores_test = ones(num_test_veds, 1, num_actions);

for i = 1:order_k
    scores_train = cat(2, scores_train, prob_training(:,1,:).^i);
    scores_test = cat(2, scores_test, prob_testing(:,1,:).^i);
end

for i = 2:num_feas
    tmp_ind_mat = ind_mat;
    ind_mat = [ind_mat; zeros(1, size(ind_mat,2))];
    for j = 1:order_k
        ind_mat = [ind_mat [tmp_ind_mat; j*ones(1, size(tmp_ind_mat,2))]];
        scores_train = cat(2, scores_train, scores_train.*repmat(prob_training(:,i,:).^j, [1 size(scores_train,2) 1]));
        scores_test = cat(2, scores_test, scores_test.*repmat(prob_testing(:,i,:).^j, [1 size(scores_test,2) 1]));     
        scores_train = scores_train(:, sum(ind_mat)<=order_r, :);
        scores_test = scores_test(:, sum(ind_mat)<=order_r, :);
        ind_mat = ind_mat(:, sum(ind_mat)<=order_r);
    end
end
num_scores = size(scores_train, 2);

uc = 1:num_actions;
rates = zeros(1, num_scores);
for i = 1:num_scores
    [~, labs] = max(scores_train(:,i,:),[],3);
    for j = 1:num_train_veds
        rates(i) = rates(i) + sum(labs(j) == uc(logical(tag_train_mat(:,j))));
    end
    rates(i) = rates(i) / num_train_veds;
end
w = (rates ./ (1 + 1e-8 - rates)) .^ (1/2);
w = w * num_scores ./ sum(w);

scores_train = scores_train .* repmat(w, [num_train_veds 1 num_actions]);
scores_test = scores_test .* repmat(w, [num_test_veds 1 num_actions]);


DD = zeros(num_scores*num_actions);
D1 = zeros(num_scores*num_actions, 1);
ZZ = zeros(num_scores*num_actions);
Z1 = zeros(num_scores*num_actions, 1);
for P1 = 1:num_actions
    scores_train_cum = zeros((order_k+1)*num_feas, num_scores);
    s01 = zeros((order_k+1), 1);    
    s01(2) = 1;
    s01 = repmat(s01, [num_feas 1]);
    for m = 1:num_feas
        for k = 0:order_k
            scores_train_cum((m-1)*(order_k+1)+1+k, ind_mat(m,:)==k) = sum(scores_train(:, ind_mat(m,:)==k, P1));
        end
    end
    scores_train_cum = scores_train_cum / num_train_veds;        
    DD((P1-1)*num_scores+1:P1*num_scores, (P1-1)*num_scores+1:P1*num_scores) = ...
        scores_train_cum' * scores_train_cum / (order_k+1) / num_feas / num_actions;
    D1((P1-1)*num_scores+1:P1*num_scores) = scores_train_cum' * s01 / (order_k+1) / num_feas / num_actions;
    
    for yl2 = 1:num_actions
        if yl2 ~= P1
            ZZ((P1-1)*num_scores+1:P1*num_scores, (P1-1)*num_scores+1:P1*num_scores) = ...
                ZZ((P1-1)*num_scores+1:P1*num_scores, (P1-1)*num_scores+1:P1*num_scores) + ...
                scores_train(logical(tag_train_mat(P1,:)),:,P1)' * scores_train(logical(tag_train_mat(P1,:)),:,P1);
            ZZ((yl2-1)*num_scores+1:yl2*num_scores, (yl2-1)*num_scores+1:yl2*num_scores) = ...
                ZZ((yl2-1)*num_scores+1:yl2*num_scores, (yl2-1)*num_scores+1:yl2*num_scores) + ...
                scores_train(logical(tag_train_mat(P1,:)),:,yl2)' * scores_train(logical(tag_train_mat(P1,:)),:,yl2);
            ZZ((P1-1)*num_scores+1:P1*num_scores, (yl2-1)*num_scores+1:yl2*num_scores) = ...
                ZZ((P1-1)*num_scores+1:P1*num_scores, (yl2-1)*num_scores+1:yl2*num_scores) - ...
                scores_train(logical(tag_train_mat(P1,:)),:,P1)' * scores_train(logical(tag_train_mat(P1,:)),:,yl2);
            ZZ((yl2-1)*num_scores+1:yl2*num_scores, (P1-1)*num_scores+1:P1*num_scores) = ...
                ZZ((yl2-1)*num_scores+1:yl2*num_scores, (P1-1)*num_scores+1:P1*num_scores) - ...
                scores_train(logical(tag_train_mat(P1,:)),:,yl2)' * scores_train(logical(tag_train_mat(P1,:)),:,P1);
            Z1((P1-1)*num_scores+1:P1*num_scores) = ...
                Z1((P1-1)*num_scores+1:P1*num_scores) + ...
                scores_train(logical(tag_train_mat(P1,:)),:,P1)' * ...
                (tag_train_mat(P1,logical(tag_train_mat(P1,:))) - tag_train_mat(yl2,logical(tag_train_mat(P1,:))))';
            Z1((yl2-1)*num_scores+1:yl2*num_scores) = ...
                Z1((yl2-1)*num_scores+1:yl2*num_scores) - ...
                scores_train(logical(tag_train_mat(P1,:)),:,yl2)' * ...
                (tag_train_mat(P1,logical(tag_train_mat(P1,:))) - tag_train_mat(yl2,logical(tag_train_mat(P1,:))))';
        end
    end
end
ZZ = ZZ / (num_actions - 1) / num_train_veds;
Z1 = Z1 / (num_actions - 1) / num_train_veds;

cond_DM_train = zeros(num_train_veds,num_actions);
cond_DM = zeros(num_test_veds,num_actions);

PP = lamda * miu / (miu + lamda / num_train_veds/ (num_actions-1))*ZZ ...
    + DD + miu * eye(num_scores * num_actions);
P1 = lamda^2 / (miu * num_train_veds * (num_actions-1)+lamda)*Z1 + D1;

alpha =  PP \ P1;

for i = 1:num_actions
    tmp_alpha = alpha(num_scores*(i-1)+1:num_scores*i);
    cond_DM_train(:,i) = scores_train(:,:,i)*tmp_alpha;
    cond_DM(:,i) = scores_test(:,:,i)*tmp_alpha;
end


